routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


Route::resource('/school', 'FormController');

Route::get('/task',function (){
    return view('task');
});






Auth::routes();

//Route::get('/home', 'HomeController@index')->name('home');

app/Models/School.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class School extends Model
{


    protected $fillable = ['title','question','subject','type','price','image'];

    public function getAllStudent(){
        return $this->orderBy('id','ASC')->get();

    }

    public function getRules(){
        $rules = array(
            'title' => 'required|string',
            'question' => 'required|string',
            'subject' =>'required',
            'type' => 'required',
            'price' => 'required',
            'image' => 'sometimes|image|max:2048'
        );
        return $rules;
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/ApiController.php
<?php

namespace App\Http\Controllers;

use App\Models\School;
use Illuminate\Http\Request;

class ApiController extends Controller
{
    public function getHomeContent(){
        $school = new School();

        $school = $school->all();



    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/FormController.php
<?php

namespace App\Http\Controllers;

use App\Models\School;
/*use Faker\Provider\Image;*/
use Illuminate\Http\Request;
use File;
use Image;

class formController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $school = new School();
       //dd($school);

        $data = $school->getAllStudent();
       // dd($data);


        return view('list_form')
            ->with('page_title',"Student List")
            ->with('title','Student Table')
            ->with('list_form',$data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('form');

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $school = new School();

        $rules = $school->getRules();


        $request->validate($rules);

        $data = $request->all();


        if($request->has('image')){
           $file_name = "Image-".date('Ymdhis').rand(0,999).".".$request->image->getClientOriginalExtension();
           //dd($file_name);
           $path = public_path().'/upload';
           //dd($path);
            if(!File::exists($path)){
                File::makeDirectory($path, 0777, true, true);
            }
            $success = $request->image->move($path, $file_name);
            if($success){

                $thumb_name = "Thumb-".$file_name;
                Image::make($path.'/'.$file_name)->resize(200,200, function ($constraint){

                    $constraint->aspectRatio();
                })->save($path.'/'.$thumb_name);

                $data['image']= $file_name;
            }else{
                $data['image'] = null;
            }
          //  dd($data);


        }

        //dd($school);
        $school->fill($data);

        $status = $school->save();
        // dd($status);
        return redirect(route('school.index'));

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $school = new School();
        dd($school);

        return view('news_detail');

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $school = new School();
       //dd($school);

        $school = $school->find($id);


        if(!$school){
           return  redirect(route('school.index'));
       }

       return view('form')
           ->with('school_data', $school);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $school = new School();
        $school = $school->find($id);

        $rules = $school->getRules();

        $request->validate($rules);
        $data = $request->all();


        if($request->has('image')){
            $file_name = "Image-".date('Ymdhis').rand(0,999).".".$request->image->getClientOriginalExtension();
            //dd($file_name);
            $path = public_path().'/upload';
            //dd($path);
            if(!File::exists($path)){
                File::makeDirectory($path, 0777, true, true);
            }
            $success = $request->image->move($path, $file_name);
            if($success){

                $thumb_name = "Thumb-".$file_name;
                Image::make($path.'/'.$file_name)->resize(200,200, function ($constraint){

                    $constraint->aspectRatio();
                })->save($path.'/'.$thumb_name);

                $data['image']= $file_name;
            }else{
                $data['image'] = null;
            }
            //  dd($data);


        }

        //dd($school);
        $school->fill($data);

        $status = $school->save();
        // dd($status);
        return redirect(route('school.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $school = new School();
        //dd($school);
        $school = $school->find($id);

        if($school){
            $school->delete();
        }
        return redirect(route('school.index'));
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

resources/views/form.blade.php
@extends('layouts.master')
@section('content')

    <div class="col-12">
        <h4 class="text-center">Question {{ isset($school_data) ? 'Update' : "Add" }}</h4>
        <hr>

        @if(isset($school_data))
            <form action="{{ route('school.update',$school_data->id) }}" method="post" enctype="multipart/form-data"
                  class="form-">
                @method('patch')
                @else
                    <form action="{{ route('school.store') }}" method="post" enctype="multipart/form-data"
                          class="form-">
                        @endif
                        @csrf

                        <div class="form-group row">
                            <label for="" class="col-sm-3">Title:</label>
                            <div class="col-sm-9">
                                <input type="text" name="title" value="{{@$school_data->title }}" id="title"
                                       class="form-control form-control-sm">
                                @error('title')
                                <span class="alert-danger">{{$message}}</span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="" class="col-3">Your Question:</label>
                            <div class="col-9">
                                <textarea name="question" id="question" rows="5" class="form-control form-control-sm"
                                          style="resize: none;">{{@$school_data->question}}</textarea>
                                @error('question')
                                <span class="alert-danger">{{$message}}</span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="" class="col-sm-3">Subject:</label>
                            <div class="col-sm-9">
                                <select name="subject"  id="subject" class="form-control form-control-sm">
                                    <option value="BCA">BCA</option>
                                    <option value="BIT">BIT</option>
                                    <option value="CSIT">CSIT</option>
                                    <option value="BBM">BBM</option>
                                </select>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="" class="col-sm-3">Type:</label>
                            <div class="col-sm-9">
                                <select name="type" id="type" class="form-control form-control-sm">
                                    <option value="short">Short</option>
                                    <option value="long">Long</option>
                                    <option value="verylong">Very Long</option>

                                </select>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="" class="col-3">Price:</label>
                            <div class="col-9">
                                <select name="price" id="price" class="form-control form-control-sm">
                                    <option value="500">500</option>
                                    <option value="200">200</option>
                                    <option value="400">400</option>
                                    <option value="100">100</option>
                                </select>
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="" class="col-3">Image:</label>
                            <div class="col-6">
                                <input type="file" value="" onchange="readURL(this)" name="image" accept="*/*">
                            </div>
                            <div class="col-3">
                                <img src="{{ @asset('upload/'.$school_data->image) }}" alt="" id="thumb" class="img img-thumbnail">
                            </div>

                        </div>




                        <div class="form-group row">
                            <label for="" class="col-3"></label>
                            <div class="col-9">
                                <button class="btn btn-warning" type="reset">
                                    Reset
                                </button>
                                <button class="btn btn-primary" type="submit">
                                    Submit
                                </button>
                            </div>
                        </div>

                    </form>
    </div>
@endsection



@section('script')
    <script>
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();
                reader.onload = function (e) {
                    $('#thumb').attr('src', e.target.result);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }
    </script>



@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Dashboard</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script
        src="http://code.jquery.com/jquery-3.4.1.min.js"
        integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
        crossorigin="anonymous"></script>
    <script src="{{ asset('js/bootstrap.min.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/bootstrap.min.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/layouts/master.blade.php
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>@yield('title')</title>
    <link rel="stylesheet" href="{{ asset('css/bootstrap.min.css') }}">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
</head>
<body>
<div class="container-fluid">
    <div class="row">
        @yield('content')
    </div>
</div>


@yield('script')
</body>
</html>

resources/views/list_form.blade.php
@extends('layouts.master')
@section('title','Student List')


@section('content')
<div class="col-12">
    <h4 class="text-center">{{$title}}</h4>
    @include('section.create')
    <hr>
    <table class="table">
        <thead class="thead-dark">
        <th>S.N</th>
        <th>Title</th>
        <th>Question</th>
        <th>Subject</th>
        <th>Type</th>
        <th>Price</th>
        <th>Image</th>
        <th>Action</th>
        <th>Download</th>

        </thead>
        <tbody>
        {{--  {{$list_form}}--}}
        @foreach($list_form as $key =>$list_info)
            <tr>
                <td>{{$key+1}}</td>
                <td>{{$list_info->title}}</td>
                <td>{{$list_info->question}}</td>
                <td>{{$list_info->subject}}</td>
                <td>{{$list_info->type}}</td>
                <td>{{$list_info->price}}</td>
                <td>
                    <img src="{{ asset('upload/'.$list_info->image) }}" alt="" style="max-width: 100px" class="img img-responsive img-thumbnail">
                </td>
                <td>
                    <div class="form-group row">
                        <a href="{{route('school.edit',$list_info->id)}}"><button class=" btn btn-success btn-sm">Edit</button></a>

                        <form onsubmit="return confirm('Are you sure you want to delete this student ?')" action="{{route('school.destroy',$list_info->id)}}" method="post">
                            @csrf
                            @method('delete')
                            <button class=" btn btn-danger btn-sm">Delete</button>

                        </form>
                        <form action=" {{route('school.show',$list_info->id)}}" method="get">
                            @csrf
                            @method('show')
                            <button class=" btn btn-secondary btn-sm">View</button>

                        </form>
                    </div>
                </td>
                <td>Download</td>
            </tr>
        @endforeach
        </tbody>
    </table>

</div>
@endsection

resources/views/news_detail.blade.php
@extends('layouts.master')
@section('title','Student view')
@section('content')
    <div class="col-12">
        <h1 class="text-center">Student Detail</h1>
        <hr>

    </div>


@endsection

resources/views/section/create.blade.php
<div class="container">

    <div class="col-12 ">
        <a href="{{route('school.create')}}">
            <button class="btn btn-primary">Create</button>
        </a>
    </div>
</div>